Subject: Re: [PATCH net-next v3 00/14] net: bridge: reduce multicast checks in fast path

From: Simon Horman <[email-masked]>
Date: Tue, 3 Mar 2026 12:14:11 +0000

On Mon, Mar 02, 2026 at 06:39:54AM +0100, Linus Lüssing wrote:
> This patchset introduces new state variables to combine and reduce the
> number of checks we would otherwise perform on every multicast packet
> in fast/data path. Instead of checking if our querier is enabled or
> if another querier timer is pending, plus if the initial query
> grace period has elapsed, plus for IPv6 and for our own querier if we
> have an IPv6 address yet - and all this for every multicast packet -
> we can now simply check one boolean state variable per protocol family
> combining all this, the new ip{4,6}_active. Or MCAST_ACTIVE_V4 /
> MCAST_ACTIVE_V6 to netlink/userspace.
>   
> The second reason for introducing these new, internal multicast active
> variables is to later propagate a safety mechanism which was introduced
> in commit b00589af3b04 ("bridge: disable snooping if there is no querier")
> to switchdev/DSA, too. That is to notify switchdev/DSA if multicast
> snooping can safely be applied without potential packet loss.
> 
> An example usage/integration of this with the modified Realtek rtl83xx
> switch driver can be found in a draft pull-request at the OpenWrt
> project: https://github.com/openwrt/openwrt/pull/18780
> This was tested at least on an ZyXEL GS1900-24HP v1 switch.
> 
> iproute2 patch:
> https://patchwork.kernel.org/project/netdevbpf/patch/[email-masked]/
> 
> Regards, Linus

Hi Linus,

This patch-set appears to break builds with IPV6=n.

Please take a look into that for the next version: each patch
should build when applied one by one.